unit rhsCreateDisabledImageList;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Graphics, Controls, ImgList, rhsBitmapGrayscale;

function CreateDisabledImageList(AImageList: TImageList): TImageList;

implementation

function CreateDisabledImageList(AImageList: TImageList): TImageList;
var
  Resolution: TCustomImageListResolution;
  BM: TCustomBitmap;
  i: Integer;
begin
  try
    Result := TImageList.Create(AImageList);
    AImageList.AssignTo(Result);
    Result.Scaled := AImageList.Scaled;
    BM := TBitmap.Create;
    for i := 0 to Result.Count - 1 do
    begin
      for Resolution in Result.Resolutions do
      begin
        Resolution.GetBitmap(i, BM);
        BitmapGrayScale(BM, 0.30, 0.59, 0.11);
        Resolution.ImageList.Replace(i, BM, nil, False);
      end;
    end;
  finally
    BM.Free;
  end;
end;

end.
